#ifndef __MAINWINDOW_HPP
#define __MAINWINDOW_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(MainWindow)

class MainWindow : public SFRTitleWindow {

    SFMSEALCOPY(MainWindow)

private:

    // Head of lines to display
    SInt16 _displine;
    // Cursor position
    SInt16 _cursor;
    // Number of lines to display
    SInt16 _maxline;
    // Rectangle of line currently pointed to by cursor
    SFXRectangle _currentRect;
    // Number of horizontal spaces text will move
    SInt16 _moveX;
    // Number of vertical spaces text will move
    SInt16 _moveY;

public:

    MainWindow(SInt16 softkeyHeight);
    static Void SetSoftkey(Void);

private:

    // Drawing handler
    HANDLER_DECLARE_VOIDRENDER(OnRenderContent)
    // Key handler
    HANDLER_DECLARE_BOOLEVENT(OnKey)
};

#endif //__MAINWINDOW_HPP
