//
//      RssReader.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1 (English Edition)
//

#include "RssReader.hpp"
#include "MainWindow.hpp"
#include "SoftkeyWindow.hpp"

//
// Boot loader.
//
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://"
        "T3TKYMVCX9VNX4TLSNW4WAXKW9UBRMWJTCUIZ1TJJY7WDVGR2YQS6VGXESQU3VQXCV1X"
        "FTBWGRER1S9X0PTIX2S3W9YDU7U8YGXER3WGTQV3FT7UET1V3SQYOSJUKR4UFVDR66Z8"
        "U5T4TIY1DWNZ3WLW8YAXERQSBY6XCZBLS2SDOVPWJXGZ55XAUOWF5WQ2VKHV2T0V5Y7V"
        "9WER8Z1YJRDWJV3YGRLU4LX5S2R1V9PY8SNWISDTASAZ6UFV3RDTEP4VQSKDRGU4RAX1"
        "DQU6R8VPU3Y2CU9R0TMVFYHZ6JR8RKR7RMAS9Y27VGY6R4X6Z5VHW3VGV6GYHOV0QX1S"
        "MQYHUPGZ5SBYLUKZC/";

    return (id == AEECLSID_RSSREADER) ? (&RssReader::Factory) : (null);
}

//
// Factory function.
//
SFCInvokerPtr RssReader::Factory(Void)
{
    return ::new RssReader;
}

//
// Constructor definition.
//
RssReader::RssReader(Void) static_throws
{
    Bool b;
    SFXDirectory::Exists(DIRECTORY_PATH, &b);

    // If the directory doesn't exist
    if (!b) {
        // Create the directory
        SFXDirectory::Create(DIRECTORY_PATH);
    }

    // Data is read from the file
    _feedList.LoadFromFile();
    if (_feedList.GetSize() > 0) {
        _currentFeed = _feedList[0];
    } else {
        _currentFeed = null;
    }
    SoftkeyWindowPtr softkey = ::new SoftkeyWindow();
    if (softkey != null) {
        MainWindowPtr window = ::new MainWindow(softkey->GetHeight());
        if (window != null && _currentFeed != null) {
            // Title set to window
            window->SetTitle(GetCurrentFeed()->_title);
        }
    }

    return;
}

//
// Destructor definition.
//
RssReader::~RssReader(Void)
{
    return;
}

RSSFeedListPtr RssReader::GetRSSFeedList(Void)
{
    return &(static_cast<RssReaderPtr>(GetInstance())->_feedList);
}

RSSFeedPtr RssReader::GetCurrentFeed(Void)
{
    return static_cast<RssReaderPtr>(GetInstance())->_currentFeed;
}

Void RssReader::SetCurrentFeed(RSSFeedPtr currentFeed)
{
    static_cast<RssReaderPtr>(GetInstance())->_currentFeed = currentFeed;
    return;
}
