#ifndef __SOFTKEYWINDOW_HPP
#define __SOFTKEYWINDOW_HPP

#include <SophiaFramework.hpp>

// Define the attribute
SFMRESPONDERATTRIBUTE(SOFTKEY, four_char_code('S', 'o', 'f', 't'))

SFMTYPEDEFCLASS(SoftkeyWindow)

class SoftkeyWindow : public SFRPlainWindow {

    SFMSEALCOPY(SoftkeyWindow)

private:

    // Character string displayed on the left
    SFXAnsiString _left;
    // Character string displayed at center
    SFXAnsiString _center;
    // Character string displayed on the right
    SFXAnsiString _right;

public:

    SoftkeyWindow(Void) static_throws;
    static SoftkeyWindowPtr GetInstance(Void);
    SInt16 GetHeight(Void);
    Void Set(SFXAnsiStringConstRef left = SFXAnsiString::EmptyInstance(),
    SFXAnsiStringConstRef center = SFXAnsiString::EmptyInstance(),
    SFXAnsiStringConstRef right = SFXAnsiString::EmptyInstance());

private:

    HANDLER_DECLARE_VOIDRENDER(OnRenderContent)
};

#endif //__SOFTKEYWINDOW_HPP
