#ifndef __SUBSCRIPTIONWINDOW_HPP
#define __SUBSCRIPTIONWINDOW_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(SubscriptionWindow)

class SubscriptionWindow : public SFRTitleWindow {

    SFMSEALCOPY(SubscriptionWindow)

private:

    // Head of displayed line
    SInt16 _displine;
    // Cursor position
    SInt16 _cursor;
    // The displayed number of lines
    SInt16 _maxline;                        
    // Number of horizontal spaces that text will move
    SInt16 _move;
    // HTTP connection
    SFXHTTPConnection _http;
    // Stream for receiving data
    SFXAnsiStringStreamReader _reader;
    // String for saving received data
    SFXAnsiString _xml;
    // Rectangle of line currently pointed by cursor
    SFXRectangle _currentRect;


public:

    SubscriptionWindow(SFXRectangleConstRef rectangle) static_throws;
    static Void SetSoftkey(Void);

private:

    Void DisplayErrorDialog(Void);
    Void UpdateMainWindow(Void);

    // Drawing handler
    HANDLER_DECLARE_VOIDRENDER(OnRenderContent)
    // Key handler
    HANDLER_DECLARE_BOOLEVENT(OnKey) static_throws
    // Dialog handler
    HANDLER_DECLARE_VOIDDIALOG(StartConnection) static_throws
    // Callback for when HTTP connection begins
    CALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)
    // Callback for when data is received over HTTP
    CALLBACK_DECLARE_SFXBINARYSTREAMREADER(FetchCallback)
};

#endif //__SUBSCRIPTIONWINDOW_HPP
